'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactMoleculeDropdownList = require('@s-ui/react-molecule-dropdown-list');

var _reactMoleculeDropdownList2 = _interopRequireDefault(_reactMoleculeDropdownList);

var _reactAtomInput = require('@s-ui/react-atom-input');

var _reactAtomInput2 = _interopRequireDefault(_reactAtomInput);

var _withSelectUI = require('../hoc/withSelectUI');

var _withSelectUI2 = _interopRequireDefault(_withSelectUI);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MoleculeInputSelect = (0, _withSelectUI2.default)(_reactAtomInput2.default);

var MoleculeSelectSingleSelection = function MoleculeSelectSingleSelection(props) {
  /* eslint-disable react/prop-types */
  var _props$value = props.value,
      value = _props$value === undefined ? '' : _props$value,
      children = props.children,
      isOpen = props.isOpen,
      onToggle = props.onToggle,
      onChange = props.onChange,
      iconArrowDown = props.iconArrowDown,
      refMoleculeSelect = props.refMoleculeSelect,
      size = props.size,
      placeholder = props.placeholder,
      id = props.id;


  var handleSelection = function handleSelection(ev, _ref) {
    var value = _ref.value;

    onChange(ev, { value: value });
    onToggle(ev, { isOpen: false });
    refMoleculeSelect.current.focus();
  };

  return _react2.default.createElement(
    _react.Fragment,
    null,
    _react2.default.createElement(MoleculeInputSelect, {
      id: id,
      isOpen: isOpen,
      value: value,
      onClick: onToggle,
      iconArrowDown: iconArrowDown,
      placeholder: placeholder
    }),
    _react2.default.createElement(
      _reactMoleculeDropdownList2.default,
      {
        size: size,
        visible: isOpen,
        onSelect: handleSelection,
        value: value
      },
      children
    )
  );
};

MoleculeSelectSingleSelection.displayName = 'MoleculeSelectSingleSelection';

MoleculeSelectSingleSelection.defaultProps = {
  value: ''
};

exports.default = MoleculeSelectSingleSelection;